<template>
  <div>
    <div class="card card-custom p-5 gutter-b">
      <div class="card-body p-0">
        <div class="row">
          <div class="col-md-6 py-2 col-sm-12">
            <label for="input-large">Nomor CR</label>

            <b-form-input
              id="input-large"
              size="lg"
              placeholder="Masukkan Nomor Cr"
              v-model="cr_number"
            ></b-form-input>
          </div>

          <div class="col-md-6 py-2 col-sm-12">
            <label for="input-large">Title</label>

            <b-form-input
              id="input-large"
              size="lg"
              placeholder="Masukkan Nickname"
              v-model="nickname"
            ></b-form-input>
          </div>
        </div>

        <div class="d-flex justify-content-end">
          <button class="btn btn-primary btn-md" @click.prevent="filter">
            <i class="flaticon2-search-1"></i> Filter
          </button>
        </div>
      </div>
    </div>

    <div class="card card-custom p-5 gutter-b">
      <div class="card-body p-0">
        <div class="text-right mb-3 text-success">
          <button
            class="btn btn-success btn-md"
            @click.prevent="add_change_management"
          >
            <i class="flaticon2-plus"></i>
          </button>
        </div>
        <div class="table-responsive">
          <table
            class="table table-head-custom table-vertical-center table-head-bg table-borderless"
          >
            <thead>
              <tr class="text-left">
                <th style="min-width: 250px">Nomor CR</th>
                <th style="min-width: 100px">Title</th>
                <th style="min-width: 100px">Proyek</th>
                <th style="min-width: 101px">Aksi</th>
              </tr>
            </thead>

            <tbody v-if="this.$store.getters.getterChangeManagement.length > 0">
              <template
                v-for="(item, i) in this.$store.getters.getterChangeManagement"
              >
                <tr v-bind:key="i">
                  <td>
                    <span
                      class="ml-5 text-dark-75 font-weight-bolder d-block font-size-lg"
                    >
                      {{ item.cr_number }}
                    </span>
                  </td>

                  <td>
                    <span
                      class="text-dark-75 font-weight-bolder d-block font-size-lg"
                    >
                      {{ item.title }}
                    </span>
                  </td>

                  <td>
                    <span
                      class="text-dark-75 font-weight-bolder d-block font-size-lg"
                    >
                      {{ item.project.name }}
                    </span>
                  </td>

                  <td class="pr-0">
                    <!-- <a
                                            class="btn btn-light-success font-weight-bolder font-size-sm"
                                            @click="edit(item.id)"
                                        >
                                            <div
                                                class="text-centerp d-none"
                                                v-bind:id="'loading-change-' + item.id"
                                            >
                                                <b-spinner variant="primary" style="width: 1rem; height: 1rem;" label="Spinning"></b-spinner>
                                            </div>
                                            <div
                                                class="text-center"
                                                v-bind:id="'edit-text-change-' + item.id"
                                            >
                                                <i class="flaticon-edit"></i>
                                            </div>
                                        </a> -->
                    <router-link
                      :to="{
                        name: 'change-management-detail',
                        params: { id_change_management: item.id }
                      }"
                    >
                      <div class="text-center">
                        <button class="btn btn-light-success">
                          <i class="flaticon-edit"></i>
                        </button>
                      </div>
                    </router-link>
                  </td>
                </tr>
              </template>
            </tbody>
            <tbody v-else>
              <tr>
                <td colspan="15">
                  <div class="text-center">
                    <i class="flaticon2-open-box text-secondary icon-3x"></i>

                    <h4>
                      Data kosong.
                    </h4>
                  </div>
                </td>
              </tr>
            </tbody>
          </table>
        </div>
      </div>
    </div>
  </div>
</template>

<script>
import { SET_BREADCRUMB } from "@/core/services/store/breadcrumbs.module";
import {
  GET_CHANGE_MANAGEMENT,
  GET_DETAIL_CHANGE
} from "@/core/services/store/change-management.module";

export default {
  name: "change-management",
  data() {
    return {
      cr_number: "",
      nickname: "",
      options: {
        statuses: [
          { value: null, text: "Pilih Status" },
          { value: "open", text: "Open" },
          { value: "close", text: "Close" }
        ]
      },
      data: {
        projects: [
          {
            cr_number: "LR98123",
            title: "Cr Title",
            project: {
              name:
                "PEMBANGUNAN SISTEM PERSINYALAN DAN TELEKOMUNIKASI JALUR KERETA API ANTARA MANDALLE - PALANRO LINTAS MAKASAR-PARE PARE (MYC 2019-2020)"
            }
          }
        ]
      }
    };
  },
  methods: {
    filter() {
      var cr = this.cr_number;
      var nickname = this.nickname;

      var search = {
        nickname: nickname,
        cr: cr
      };

      this.$store.dispatch(GET_CHANGE_MANAGEMENT, search);
    },

    add_change_management() {
      var url = "/project/change/management/create";
      this.$router.push(url);
    },

    openDialog() {
      this.dialog = true;
    },

    async edit(id) {
      var loading = document.getElementById("loading-change-" + id);
      var text = document.getElementById("edit-text-change-" + id);

      loading.classList.remove("d-none");
      text.classList.add("d-none");
      await this.$store.dispatch(GET_DETAIL_CHANGE, { id: id });
      loading.classList.add("d-none");
      text.classList.remove("d-none");
      this.$router.push("/project/change/management/edit");
    }
  },
  mounted() {
    this.$store.dispatch(SET_BREADCRUMB, [{ title: "Change Management" }]);

    this.$store.dispatch(GET_CHANGE_MANAGEMENT, { nickname: "", cr: "" });
  }
};
</script>

<style></style>
